Package: org.apache.groovy.contracts.ast.visitor

## [Java] Class DynamicSetterInjectionVisitor

- org.apache.groovy.contracts.ast.visitor.DynamicSetterInjectionVisitor

-     public class DynamicSetterInjectionVisitor
      extends BaseVisitor

  Implements contract support for setter methods and default constructors of POGOs.

  See Also:
    BaseVisitor

- - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class BaseVisitor` | `GCONTRACTS_ENABLED_VAR, sourceUnit`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `DynamicSetterInjectionVisitor(SourceUnit sourceUnit, ReaderSource source)` Creates a visitor that injects synthetic setters and constructors needed for invariant checks.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected Statement` | `createSetterBlock(ClassNode classNode, FieldNode field, Parameter parameter)` Creates the body of a synthetic setter that wraps the assignment with invariant checks.
    `` | `public void` | `visitClass(ClassNode classNode)` Prepares invariant-check blocks for the class and adds a synthetic default constructor when needed.
    `` | `public void` | `visitProperty(PropertyNode node)` Adds a synthetic setter for invariant-checked properties when no explicit setter is present.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class BaseVisitor` | `asConditionExecution, getOriginalCondition, getReplacedCondition, getSourceUnit, replaceCondition`
    `class ClassCodeVisitorSupport` | `addError, getSourceUnit, visitAnnotation, visitAnnotations, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClass, visitClassCodeContainer, visitClosureExpression, visitConstructor, visitConstructorOrMethod, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitStatementAnnotations, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop, visitYieldStatement`
    `class CodeVisitorSupport` | `afterSwitchCaseStatementsVisited, afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, afterSwitchConditionExpressionVisited, visitArgumentlistExpression, visitArrayExpression, visitAssertStatement, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBlockStatement, visitBooleanExpression, visitBreakStatement, visitBytecodeExpression, visitCaseStatement, visitCastExpression, visitCatchStatement, visitClassExpression, visitClosureExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitEmptyStatement, visitExpressionStatement, visitFieldExpression, visitForLoop, visitGStringExpression, visitIfElse, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitReturnStatement, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitSwitch, visitSwitchExpression, visitSynchronizedStatement, visitTernaryExpression, visitThrowStatement, visitTryCatchFinally, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression, visitWhileLoop, visitYieldStatement`

- - ### Constructor Detail

    - #### public DynamicSetterInjectionVisitor(SourceUnit sourceUnit, ReaderSource source)

      Creates a visitor that injects synthetic setters and constructors needed for invariant checks.

      Parameters:
        `sourceUnit` - the source unit currently being transformed
        `source` - the reader source backing the source unit

  - ### Method Detail

    - #### protected Statement createSetterBlock(ClassNode classNode, FieldNode field, Parameter parameter)

      Creates the body of a synthetic setter that wraps the assignment with invariant checks.

      Parameters:
        `classNode` - the declaring class
        `field` - the field being written
        `parameter` - the synthetic setter parameter
      Returns:
        the generated setter body

    - #### public void visitClass(ClassNode classNode)

      Prepares invariant-check blocks for the class and adds a synthetic default constructor when needed.

      Parameters:
        `classNode` - the class being visited

    - #### public void visitProperty(PropertyNode node)

      Adds a synthetic setter for invariant-checked properties when no explicit setter is present.

      Parameters:
        `node` - the property being visited